unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, GPanel, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    GPanel1            : TGPanel ;
      Shape1           : TShape ;
      Shape2           : TShape ;
      Shape3           : TShape ;
      Label1           : TLabel ;
      Label2           : TLabel ;
      Label3           : TLabel ;
      Label4           : TLabel ;
      Label5           : TLabel ;
      Label9           : TLabel ;
      Label10          : TLabel ;
      Label11          : TLabel ;
      GPanel3          : TGPanel ;
        Label6         : TLabel ;
        CHK_Active     : TCheckBox ;
        CHK_Horizontal : TCheckBox ;
      ScrollBar1       : TScrollBar ;
    GPanel             : TGPanel ;
      Label8           : TLabel ;
      SHint            : TLabel ;
      Label13          : TLabel ;
      Label14          : TLabel ;
      Image1           : TImage ;
      Image2           : TImage ;
      MP               : TGPanel ;
        Label7         : TLabel ;
        Label12        : TLabel ;
    ColorDialog1       : TColorDialog ;
    Timer1             : TTimer ;
    //                                               .
    procedure FormShow(Sender: TObject);
    procedure CHK_ActiveClick(Sender: TObject);
    procedure CHK_HorizontalClick(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure Label9Click(Sender: TObject);
    procedure Label10Click(Sender: TObject);
    procedure Label11Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure Show_Hint(Sender: TObject);
  end;

var
  Form1     : TForm1;
            // to Handle the HINTS                       .

implementation

{$R *.DFM}

//                                                      .
// Form related ...                                     .
//                                                      .
procedure TForm1.FormShow(Sender: TObject);
VAR Ind : Integer ;
begin
  CHK_Active.Checked     := GPanel.Active ;
  CHK_Horizontal.Checked := GPanel.Horizontal ;
  Shape1.Brush.Color     := GPanel.Color_1 ;
  Shape2.Brush.Color     := GPanel.Color_2 ;
  Shape3.Brush.Color     := GPanel.Color_3 ;
  ScrollBar1.Position    := GPanel.Percent ;
  //                                            .
  Application.OnHint     := Show_Hint ;
  SHint.Transparent      := True ;
end;
//                                                      .
//                                                      .
//                                                      .
procedure TForm1.CHK_ActiveClick(Sender: TObject);
begin
  GPanel.Active := CHK_Active.Checked ;
end;
//                                                      .
//                                                      .
//                                                      .
procedure TForm1.CHK_HorizontalClick(Sender: TObject);
begin
  GPanel.Horizontal := CHK_Horizontal.Checked ;
end;
//                                                      .
// Color related ...                                    .
//                                                      .
procedure TForm1.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Label9Click(Sender);
end;
//                                                      .
procedure TForm1.Label9Click(Sender: TObject);
begin
  ColorDialog1.Color := GPanel.Color_1 ;
  IF ColorDialog1.Execute
    THEN GPanel.Color_1 := ColorDialog1.Color ;
  Shape1.Brush.Color    := GPanel.Color_1 ;
end;
//                                                      .
procedure TForm1.Shape2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Label10Click(Sender);
end;
procedure TForm1.Label10Click(Sender: TObject);
begin
  ColorDialog1.Color := GPanel.Color_2 ;
  IF ColorDialog1.Execute
    THEN GPanel.Color_2 := ColorDialog1.Color ;
  Shape2.Brush.Color    := GPanel.Color_2 ;
end;
//                                                      .
procedure TForm1.Shape3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Label11Click(Sender);
end;
//                                                      .
procedure TForm1.Label11Click(Sender: TObject);
begin
  ColorDialog1.Color := GPanel.Color_3 ;
  IF ColorDialog1.Execute
    THEN GPanel.Color_3 := ColorDialog1.Color ;
  Shape3.Brush.Color    := GPanel.Color_3 ;
end;
//                                                      .
// Timer related work                                   .
//                                                      .
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  // 1. Check Percentage                      .
  IF ScrollBar1.Position <> GPanel.Percent
    THEN GPanel.Percent := ScrollBar1.Position ;
  // 2. Move TEXT-Panel                       .
  IF MP.Horizontal THEN
    IF ( MP.Left+MP.Width ) > ( ( GPanel.Width * 90 ) DIV 100 )
      THEN MP.Horizontal := NOT MP.Horizontal
      ELSE MP.Left := MP.Left  + 10
  ELSE
    IF MP.Left < ( ( GPanel.Width * 10 ) DIV 100 )
      THEN MP.Horizontal := NOT MP.Horizontal
      ELSE MP.Left := MP.Left  - 10 ;
end;
//                                                      .
// functions and procedures to handle HINTS             .
//                                                      .
procedure TForm1.Show_Hint(Sender: TObject);
VAR S : String ;
begin
  S := GetLongHint(Application.Hint) ;
  IF S <> '' THEN SHint.Caption := S ;
end;
//                                                      .
// END of Program                                       .
//                                                      .
end.          tor
